import java.io.*;

public class GuiThread implements Runnable {
String actionString="";
DocSearch ds;
Thread gtt;


GuiThread(DocSearch ds, String actionString) {
this.actionString=actionString;
this.ds=ds;
} // end for constructor

public void start() {
	if(gtt == null) {
            gtt = new Thread(this, "gtt");
            gtt.start();
        } // end if null
} // end for start

public void stop() {
	gtt.interrupt();
	gtt = null;
} // end for stop

public void run() {
 for(Thread thread = Thread.currentThread(); gtt == thread;)
	try {
		ds.handleEventCommand(actionString);
		} // end for try
	catch(Exception eR) 
		{ 
		System.out.println("Gui Thread error: "+eR.toString()+"\naction:"+actionString);
		eR.printStackTrace();
		}
	finally {
		stop();
		if (gtt!=null) gtt.destroy();
		} // end finally
} // end for run



} // end for MetaThread class
