
public class LinkValue {
	String href="";
	String page="";
	String realLink="";
	boolean convertedLink=false;

LinkValue(String page, String href) {
	this.href=href;
	if (href.indexOf("#")!=-1) {
		int anchorPos=href.indexOf("#");
		href=href.substring(0, anchorPos);
		}
	this.page=page;
}



public String getHref() { return href; }
public String getPage() { return page; }
public String getRealLink() { 
	if (convertedLink) {
		convertedLink=true;
		return realLink; 
		}
	else {
		String lowerRef=href.toLowerCase();
		String domainUrl=Utils.getDomainUrl(page);
		int domLen=domainUrl.length();
		String pageFold=page;
		if (!page.endsWith("/")) {
			pageFold=page.substring(0, page.lastIndexOf("/")+1);
			//System.out.println("page folder is"+pageFold);
			}
		if (lowerRef.startsWith("http")) {
			convertedLink=true;
			realLink=href;
			}
		else {
			if (lowerRef.startsWith("/")) {
				/* go up to root and make rel link */
				realLink=domainUrl+href.substring(1, href.length());
				}
			else if (lowerRef.startsWith("../")) {
				/* go up a folder - or so to make rel link */
				boolean folderFound=false;
				String newFolder=pageFold;
				String dotPoint=href;
				int lastSlash=0;
				if (newFolder.endsWith("/")) {
					lastSlash=newFolder.lastIndexOf("/");
					newFolder=newFolder.substring(0, lastSlash);
					}
				do {
					if (dotPoint.startsWith("../")) {
						dotPoint=dotPoint.substring(3, dotPoint.length());
						}
					else {
						folderFound=true;
						break;
						}
					lastSlash=newFolder.lastIndexOf("/");
					if ((lastSlash!=-1) && (newFolder.length()>domLen)) {
						newFolder=newFolder.substring(0, lastSlash);
						}
					else {
						folderFound=true;
						break;
						}
					
					} while (!folderFound);
				realLink=newFolder+"/"+dotPoint;
				//System.out.println("rel link built: "+newFolder+" + "+dotPoint);
				}
			else {
				/* assume rel link at page location */
				realLink=pageFold+href;
				}
			} // end for not a full link
		System.out.println("href="+href+"\nREAL LINK="+realLink);
		convertedLink=true;
		return realLink;
		}
} // end for getRealLink


}