import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;

public class DsProperties extends JDialog implements ActionListener {
    DocSearch monitor;
    int numPanels=2;
    static final String CANCEL=Messages.getString("DocSearch.btnCancel");
    static final String OK=Messages.getString("DocSearch.ok");
    static final String APPLY=Messages.getString("DocSearch.btnApply");
    static final String BROWSE=Messages.getString("DocSearch.btnBrowse");
    static final String SELECT=Messages.getString("DocSearch.btnSelect");
    static final String PROVIDE_IDX_DIR=Messages.getString("DocSearch.provIdxDir");
    static final String ADD=Messages.getString("DocSearch.btnAdd");
    static final String REMOVE=Messages.getString("DocSearch.lblRemove");
    static final String NEW_HANDLER=Messages.getString("DocSearch.newHandler");
    static final String EDIT_HANDLER=Messages.getString("DocSearch.editHandler");
    static final String EDIT=Messages.getString("DocSearch.btnEdit");
    static final String DS_DIR=Messages.getString("DocSearch.dsIdxDir");
    static final String DS_DIR_TAB=Messages.getString("DocSearch.lblIdxDir");
    static final String DS_DIR_EXP=Messages.getString("DocSearch.dsIdxDirExp");
    static final String COPY_DIR_FILES=Messages.getString("DocSearch.copyDirFiles");
    static final String SELECT_DS_DIR=Messages.getString("DocSearch.selectDsIdxDir");
    static final String TEMP_DIR=Messages.getString("DocSearch.tempDir");
    static final String TEMP_DIR_EXP=Messages.getString("DocSearch.tempDirExp");
    static final String SELECT_TEMP_DIR=Messages.getString("DocSearch.selectTempDir");
    static final String SELECT_WORKING_DIR=Messages.getString("DocSearch.selectWorkingDir");
    static final String WORKING_DIR_LABEL=Messages.getString("DocSearch.workingDirLbl");
    static final String WORKING_DIR_EXP=Messages.getString("DocSearch.workingDirExp");
    static final String WORKING_DIR_TITLE=Messages.getString("DocSearch.workingDirTitle");
    static final String LOAD_WEB_PAGES_EXTERNALLY=Messages.getString("DocSearch.loadExternal");
      // email config
    JPanel completeEmailPanel=new JPanel();
    JPanel emailPanel=new JPanel();
   String EMAIL_ADDRESS=Messages.getString("DocSearch.emailAddress");
   String EMAIL_ADDRESSES=Messages.getString("DocSearch.emailAddresses");
   String EMAIL_SETTINGS=Messages.getString("DocSearch.emailSettings");
   String SEND_EMAIL_NOTICE_NOTE=Messages.getString("DocSearch.sendEmail");
   String SEND_EMAIL_NOTICE=Messages.getString("DocSearch.sendMail");
   String GATEWAY_USER=Messages.getString("DocSearch.gateWayUser");
   String NOTIFICATIONS=Messages.getString("DocSearch.notifications");
   String EMAIL_GATEWAY=Messages.getString("DocSearch.emailGateway");
   String GATEWAY_PWD=Messages.getString("DocSearch.gatewayPwd");
   String REMOVE_EMAIL=Messages.getString("DocSearch.removeEmail");
   String EDIT_EMAIL=Messages.getString("DocSearch.editEmail");
   String ADD_EMAIL=Messages.getString("DocSearch.addEmail");
   String EMAIL_FORMAT=Messages.getString("DocSearch.emailFormat");
   String TEXT_FORMAT=Messages.getString("DocSearch.textFormat");
   String HTML_FORMAT=Messages.getString("DocSearch.htmlFormat");
   String MAX_FILE_SIZE=Messages.getString("DocSearch.maxFsToIdx");
   //
   JLabel maxFiSizeLbl=new JLabel(MAX_FILE_SIZE);
   JTextField maxSizeField=new JTextField(10);
   JPanel maxFileSizePanel=new JPanel();
   //
   String MAX_HITS_LABEL=Messages.getString("DocSearch.maxHitsLbl");
   String MAX_HITS_TITLE=Messages.getString("DocSearch.maxHitsTit");
   JLabel maxHitLbl=new JLabel(MAX_HITS_LABEL);
   JTextField maxField=new JTextField(5);
   JPanel maxPanel=new JPanel();
   JPanel maxAllPanel=new JPanel();
   //
   String[] emailAddresses = { "", "" };
    JList emailList=new JList(emailAddresses);
    JScrollPane emailPane=new JScrollPane(emailList);
    JPanel emailButtonsPanel=new JPanel();
    JButton editButton=new JButton(EDIT);
    JButton addButton=new JButton(ADD);
    JButton removeButton=new JButton(REMOVE);
    //
    JPanel gatewayPanel=new JPanel();
    JPanel noticePanel=new JPanel();
    JCheckBox sendEmailBx=new JCheckBox(SEND_EMAIL_NOTICE);
    JLabel sendEmailLbl=new JLabel(SEND_EMAIL_NOTICE_NOTE);
    //
    ButtonGroup bg=new ButtonGroup();
    JRadioButton textRB=new JRadioButton(TEXT_FORMAT);
    JRadioButton htmlRB=new JRadioButton(HTML_FORMAT);
    //
    JPanel gatewyp=new JPanel();
    JLabel gateWayLbl=new JLabel(EMAIL_GATEWAY);
    JTextField gateWayField=new JTextField(12);
    JPanel gatewayUserPanel=new JPanel();
    JLabel gatewayUserLbl=new JLabel(GATEWAY_USER);
    JTextField gatewayUserField=new JTextField(12);
    JPanel gatewayPwdPanel=new JPanel();
    JLabel gatewayPwdLbl=new JLabel(GATEWAY_PWD);
    JPasswordField gatewayPwdField=new JPasswordField(12);
    //
    String[] handlerItems = { "", "" };
    JList handlerList=new JList(handlerItems);
    //
    JPanel workingDirPanel=new JPanel();
    JPanel workingPanel=new JPanel();
    JLabel workingDirLbl=new JLabel(WORKING_DIR_LABEL);
    JLabel workingDirExpLbl=new JLabel(WORKING_DIR_EXP);
    JTextField workingDirField=new JTextField(12);
    JButton workingDirButton=new JButton(SELECT_WORKING_DIR);
    //
    JPanel tempDirPanel=new JPanel();
    JPanel tempFoldPanel=new JPanel();
    JLabel tempDirExpLbl=new JLabel(TEMP_DIR_EXP);
    JLabel tempDirLbl=new JLabel(TEMP_DIR);
    JTextField tempDirField=new JTextField(12);
    JButton tempDirButton = new JButton(SELECT_TEMP_DIR);
    //
    JLabel defaultHndlrLbl=new JLabel(Messages.getString("DocSearch.lblDfltHndlr"));
    JTextField defaultHndlrField=new JTextField(12);
    JButton browseButton = new JButton(BROWSE);
    //
    JPanel dsDirPanel=new JPanel();
    JLabel dsDirLabel=new JLabel(DS_DIR_EXP);
    JLabel dsDirFieldLabel=new JLabel(DS_DIR);
    JButton dsSelDirButton=new JButton(SELECT_DS_DIR);
    JCheckBox copyDirFiles=new JCheckBox(COPY_DIR_FILES);
    JTextField dsDirField=new JTextField(12);
    //
    JCheckBox loadExternal=new JCheckBox(LOAD_WEB_PAGES_EXTERNALLY);
    //
    JButton okButton = new JButton(APPLY);
    JButton cancelButton = new JButton(CANCEL);
    //
    JButton addEmailButton = new JButton(ADD_EMAIL);
    JButton removeEmailButton = new JButton(REMOVE_EMAIL);
    JButton editEmailButton = new JButton(EDIT_EMAIL);
    //
    JPanel allDirsPanel=new JPanel();
    //
    JPanel bp = new JPanel();
    JPanel leftSideListPanel=new JPanel();
    JScrollPane listPane=new JScrollPane(handlerList);
    JPanel rightButPanel=new JPanel();
    JPanel rbp=new JPanel();
    JPanel [] panels;
    JTabbedPane tp=new JTabbedPane();
    //
    boolean confirmed = false;
    int returnInt=-1;
    String lafChosen="";
    //
	JPanel uiPanel=new JPanel();
	String[] uiList= { "" };
	JComboBox uiChoice=new JComboBox(uiList);
	JLabel uiLabel=new JLabel(Messages.getString("DocSearch.uiChoice"));

    DsProperties(DocSearch monitor,
               String title,
               boolean modal) {
        super(monitor, title, modal);
        this.monitor = monitor;
	listPane.setPreferredSize(new Dimension(350,200));
        // set up the buttons
        okButton.addActionListener(this);
        cancelButton.addActionListener(this);
        browseButton.addActionListener(this);
	removeButton.addActionListener(this);
	editButton.addActionListener(this);
	addButton.addActionListener(this);
	sendEmailBx.addActionListener(new CbListener());
	removeEmailButton.addActionListener(this);
	editEmailButton.addActionListener(this);
	addEmailButton.addActionListener(this);
	//
	dsSelDirButton.addActionListener(this);
	tempDirButton.addActionListener(this);
	workingDirButton.addActionListener(this);
	//
	workingDirPanel.add(workingDirLbl);
	workingDirPanel.add(workingDirField);
	workingDirPanel.add(workingDirButton);
	//
	workingPanel.setLayout(new BorderLayout());
	workingPanel.setBorder(new TitledBorder(WORKING_DIR_TITLE));
	workingPanel.add(workingDirExpLbl,BorderLayout.NORTH);
	workingPanel.add(workingDirPanel,BorderLayout.CENTER);
	//
	maxPanel.add(maxHitLbl);
	maxPanel.add(maxField);
	//
	maxAllPanel.setLayout(new BorderLayout());
	//maxAllPanel.setBorder(new TitledBorder(MAX_HITS_TITLE));
	maxAllPanel.add(maxPanel,BorderLayout.CENTER);
	//
	tempFoldPanel.add(tempDirLbl);
	tempFoldPanel.add(tempDirField);
	tempFoldPanel.add(tempDirButton);
	//
	tempDirPanel.setLayout(new BorderLayout());
	tempDirPanel.setBorder(new TitledBorder(TEMP_DIR));
	tempDirPanel.add(tempDirExpLbl,BorderLayout.NORTH);
	tempDirPanel.add(tempFoldPanel,BorderLayout.CENTER);
	//
	JPanel uiP=new JPanel();
	uiP.add(uiLabel);
	uiP.add(uiChoice);
	//
	maxFileSizePanel.add(maxFiSizeLbl);
	maxFileSizePanel.add(maxSizeField);
	JPanel mfsW=new JPanel();
	mfsW.add(maxFileSizePanel);
	//
	JPanel comMaxP=new JPanel();
	comMaxP.setLayout(new BorderLayout());
	comMaxP.add(mfsW,BorderLayout.NORTH);
	comMaxP.add(maxAllPanel,BorderLayout.CENTER);
	JPanel cmpW=new JPanel();
	cmpW.add(comMaxP); 
	//
	uiPanel.setLayout(new BorderLayout());
	uiPanel.add(uiP,BorderLayout.NORTH);
	uiPanel.add(cmpW,BorderLayout.CENTER);
	uiPanel.add(loadExternal, BorderLayout.SOUTH);
	JPanel uiWrap=new JPanel();
	uiWrap.add(uiPanel);
	//
	bg.add(textRB);
	bg.add(htmlRB);
        //
	leftSideListPanel.add(listPane);
	//
        bp.add(okButton);
        bp.add(cancelButton);
	//
	JPanel dirFieldPanel=new JPanel();
	dirFieldPanel.add(dsDirFieldLabel);
	dirFieldPanel.add(dsDirField);
	dirFieldPanel.add(dsSelDirButton);
	//
	dsDirPanel.setLayout(new BorderLayout());
	dsDirPanel.setBorder(new TitledBorder(DS_DIR));
	dsDirPanel.add(dsDirLabel,BorderLayout.NORTH);
	dsDirPanel.add(dirFieldPanel,BorderLayout.CENTER);
	dsDirPanel.add(copyDirFiles,BorderLayout.SOUTH);
	//
	allDirsPanel.setLayout(new BorderLayout());
	allDirsPanel.add(tempDirPanel,BorderLayout.NORTH);
	allDirsPanel.add(dsDirPanel,BorderLayout.CENTER);
	allDirsPanel.add(workingPanel, BorderLayout.SOUTH);
	//
	JPanel dp=new JPanel();
	dp.add(allDirsPanel);
	//
	rightButPanel.setLayout(new BorderLayout());
	rightButPanel.add(addButton,BorderLayout.NORTH);
	rightButPanel.add(removeButton,BorderLayout.CENTER);
	rightButPanel.add(editButton,BorderLayout.SOUTH);
	rbp.add(rightButPanel);
        // load up the GUI
        //
        okButton.setMnemonic(KeyEvent.VK_A);
        okButton.setToolTipText(APPLY);
        //
        //
        cancelButton.setMnemonic(KeyEvent.VK_C);
        cancelButton.setToolTipText(CANCEL);
        //
	browseButton.setMnemonic(KeyEvent.VK_B);
        browseButton.setToolTipText(BROWSE);
	//
	JPanel hndlerPanel=new JPanel();
	JPanel lowerHP=new JPanel();
	JPanel upperHP=new JPanel();
	upperHP.setLayout(new BorderLayout());
	upperHP.setBorder(new TitledBorder(Messages.getString("DocSearch.hndlrTitle")));
	upperHP.add(leftSideListPanel,BorderLayout.WEST);
	upperHP.add(rbp,BorderLayout.EAST);
	lowerHP.add(defaultHndlrLbl);
	lowerHP.add(defaultHndlrField);
	lowerHP.add(browseButton);
	//
	hndlerPanel.setLayout(new BorderLayout());
	hndlerPanel.add(upperHP,BorderLayout.CENTER);
	hndlerPanel.add(lowerHP,BorderLayout.SOUTH);
	//
       //
	emailButtonsPanel.setLayout(new BorderLayout());
	emailButtonsPanel.add(addEmailButton,BorderLayout.NORTH);
	emailButtonsPanel.add(removeEmailButton,BorderLayout.CENTER);
	emailButtonsPanel.add(editEmailButton,BorderLayout.SOUTH);
	JPanel emailCPpanel=new JPanel();
	emailCPpanel.add(emailButtonsPanel);
	//
	gatewayPwdPanel.add(gatewayPwdLbl);
	gatewayPwdPanel.add(gatewayPwdField);
	//
	gatewyp.add(gateWayLbl);
	gatewyp.add(gateWayField);
	//
	gatewayUserPanel.add(gatewayUserLbl);
	gatewayUserPanel.add(gatewayUserField);
	//
	gatewayPanel.setLayout(new BorderLayout());
	gatewayPanel.setBorder(new TitledBorder(EMAIL_GATEWAY));
	gatewayPanel.add(gatewyp, BorderLayout. NORTH);
      gatewayPanel.add(gatewayUserPanel, BorderLayout.CENTER);
      gatewayPanel.add(gatewayPwdPanel, BorderLayout.SOUTH);
       //
	//
	JPanel formatPanel=new JPanel();
	formatPanel.setLayout(new BorderLayout());
	formatPanel.setBorder(new TitledBorder(EMAIL_FORMAT));
	formatPanel.add(textRB,BorderLayout.NORTH);
	formatPanel.add(htmlRB,BorderLayout.CENTER);
	//
	JPanel combinedFormatGatewayPanel=new JPanel();
	combinedFormatGatewayPanel.setLayout(new BorderLayout());
	combinedFormatGatewayPanel.add(gatewayPanel, BorderLayout.CENTER);
	combinedFormatGatewayPanel.add(formatPanel, BorderLayout.EAST);
	//
	noticePanel.setLayout(new BorderLayout());
	noticePanel.setBorder(new TitledBorder(EMAIL_SETTINGS));
      noticePanel.add(sendEmailLbl, BorderLayout.NORTH);
      noticePanel.add(sendEmailBx, BorderLayout.CENTER);
	//
	emailPanel.setLayout(new BorderLayout());
	emailPanel.setBorder(new TitledBorder(EMAIL_ADDRESSES));
      emailPanel.add(emailPane, BorderLayout.CENTER);
      emailPanel.add(emailCPpanel, BorderLayout.EAST);
	//
	completeEmailPanel.setLayout(new BorderLayout());
      completeEmailPanel.add(noticePanel, BorderLayout.NORTH);
      completeEmailPanel.add(emailPanel, BorderLayout.CENTER);
      completeEmailPanel.add(combinedFormatGatewayPanel, BorderLayout.SOUTH);
	
	tp.addTab(Messages.getString("DocSearch.hndlersTab"), null, hndlerPanel,
                          Messages.getString("DocSearch.hndlersTabInf"));
	tp.addTab(Messages.getString("DocSearch.guiStuff"), null, uiWrap,
                          Messages.getString("DocSearch.guiStuffInf"));
	tp.addTab(DS_DIR_TAB, null, dp, DS_DIR_EXP);
	tp.addTab(NOTIFICATIONS, null, completeEmailPanel, NOTIFICATIONS);
	//
	panels=new JPanel[numPanels];
	for (int i=0;i<numPanels;i++) panels[i]=new JPanel();
	panels[0].add(tp);
	//
	panels[numPanels-1].add(bp);
	//
        // NOW PLACE THE GUI ONTO A GRIDBAG
        // put in the gridbag stuff
        getContentPane().setLayout(new GridLayout(1, numPanels));
        GridBagLayout gridbaglayout = new GridBagLayout();
        GridBagConstraints gridbagconstraints = new GridBagConstraints();
        getContentPane().setLayout(gridbaglayout);
        //
	for (int i=0;i<numPanels;i++) {
        	gridbagconstraints.fill = 1;
        	gridbagconstraints.insets = new Insets(1, 1, 1, 1);
        	gridbagconstraints.gridx = 0;
        	gridbagconstraints.gridy = i;
        	gridbagconstraints.gridwidth = 1;
        	gridbagconstraints.gridheight = 1;
        	gridbagconstraints.weightx = 0.0D;
        	gridbagconstraints.weighty = 0.0D;
        	gridbaglayout.setConstraints(panels[i], gridbagconstraints);
        	getContentPane().add(panels[i]);
		}

    }

    public void init() {
    	//
	setLafs();
	setList();
	defaultHndlrField.setText(monitor.defaultHndlr);
	dsDirField.setText(monitor.indexDir);
	tempDirField.setText(monitor.tempDir);
	workingDirField.setText(monitor.workingDir);
	if (monitor.emailFormat.equals(TEXT_FORMAT)) textRB.setSelected(true);
	else if (monitor.emailFormat.equals(HTML_FORMAT)) htmlRB.setSelected(true);
	else textRB.setSelected(true);
	maxField.setText(""+monitor.maxNumHitsShown);
	//
	Object [] emls=monitor.getEmails();
	if (emls!=null) emailList.setListData(emls);
	gateWayField.setText(monitor.gateway);
	gatewayPwdField.setText(monitor.gatewayPwd);
	gatewayUserField.setText(monitor.gatewayUser);
	if (monitor.sendEmailNotice.equals("true")) sendEmailBx.setSelected(true);
	cb();
	//
        pack();
        // center this dialog
        Rectangle frameSize = getBounds();
        Dimension screenD = Toolkit.getDefaultToolkit().getScreenSize();
        int screenWidth = screenD.width;
        int screenHeight = screenD.height;
        int newX = 0;
        int newY = 0;
        if (screenWidth > frameSize.width) newX = (screenWidth - frameSize.width) / 2;
        if (screenHeight > frameSize.height) newY = (screenHeight - frameSize.height) / 2;
         if ((newX != 0) || (newY != 0)) setLocation(newX, newY);
	if (monitor.loadExternal) loadExternal.setSelected(true);
	else loadExternal.setSelected(false);
	long mfs=(monitor.getMaxFileSize()/1024);
	maxSizeField.setText(""+mfs);
    }

    public void actionPerformed(ActionEvent actionevent) {
        String s = actionevent.getActionCommand();
        if (s.equals(APPLY)) {
		returnInt=tp.getSelectedIndex();
		String newIndexDir=dsDirField.getText().trim();
		if ((returnInt==2) && (newIndexDir.equals(""))) monitor.showMessage(monitor.dsErr, PROVIDE_IDX_DIR);
		else {
			confirmed = true;
			this.setVisible(false);
			}
        }
         // end for ok
	else if (s.equals(ADD)) {
		NewHandlerDialog nhd=new NewHandlerDialog(monitor, NEW_HANDLER, true);
		nhd.init();
		nhd.setVisible(true);
		if (nhd.returnBool) {
			//
			docTypeHandler dh=new docTypeHandler(nhd.extField.getText(), 
				nhd.descField.getText(), nhd.appField.getText());
			monitor.handlerList.add(dh);
			setList();
			}
		} // end for adding a handler
	else if (s.equals(REMOVE)) {
		int chosen=handlerList.getSelectedIndex();
		if (chosen!=-1) {
			removeItemAt(chosen);
			monitor.handlerList.remove(chosen);
			setList();
			}
		} // end for adding a handler
	else if (s.equals(EDIT)) {
		int chosen=handlerList.getSelectedIndex();
		if (chosen!=-1) {
			//
			NewHandlerDialog nhd=new NewHandlerDialog(monitor, EDIT_HANDLER, true);
			// set the values of the selected item
			nhd.init();
			nhd.setDTH((docTypeHandler)monitor.handlerList.get(chosen));
			nhd.setVisible(true);
			if (nhd.returnBool) {
				docTypeHandler dh=(docTypeHandler)monitor.handlerList.get(chosen);
				dh=new docTypeHandler(nhd.extField.getText(), 
					nhd.descField.getText(), 
					nhd.appField.getText());
				monitor.handlerList.set(chosen,dh);
				setList();
				}
			} // end for item chosen
		} // end for editing a handler
        else if (s.equals(BROWSE)) {
            JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
	    fdo.setFileSelectionMode(JFileChooser.FILES_ONLY);
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                defaultHndlrField.setText(fNa);
            }
        }
	// 
        else if (s.equals(SELECT_WORKING_DIR)) {
            JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.workingDir));
	    fdo.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                workingDirField.setText(fNa);
            }
        }
        else if (s.equals(SELECT_TEMP_DIR)) {
            JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.userHome));
	    fdo.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                tempDirField.setText(fNa);
            }
        }
        else if (s.equals(CANCEL)) {
            confirmed = false;
            this.setVisible(false);
        }
	else if (s.equals(REMOVE_EMAIL)) {
		int itemNo=emailList.getSelectedIndex();
		if (itemNo!=-1) removeEmailItem(itemNo);
	}
	else if (s.equals(ADD_EMAIL)) {
		DsEmail me=new DsEmail(this, ADD+" "+EMAIL_ADDRESS, true);
		me.init();
		me.setVisible(true);
		if (me.confirmed) {
			//
			String em=me.nameField.getText();
			if (!em.equals("")) addEmail(em);
			} // end for me
	}
	else if (s.equals(EDIT_EMAIL)) {
		int itemNo=emailList.getSelectedIndex();
		if (itemNo!=-1) {
			DsEmail me=new DsEmail(this, EDIT+" "+EMAIL_ADDRESS, true);
			me.init();
			me.nameField.setText(monitor.getEmail(itemNo));
			me.setVisible(true);
			if (me.confirmed) {
				String newEm=me.nameField.getText();
				if (!newEm.equals("")) replaceEmail(itemNo, newEm);
			}
		}
	}
	else if (s.equals(SELECT_DS_DIR)) {
            JFileChooser fdo = new JFileChooser();
            fdo.setCurrentDirectory(new File(monitor.indexDir));
	    fdo.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            int fileGotten = fdo.showDialog(this, SELECT);
            if (fileGotten == JFileChooser.APPROVE_OPTION) {
                File file = fdo.getSelectedFile();
                String fNa = file.toString();
                dsDirField.setText(fNa);
            }
        }
    }

 public void setList() {
   int numHndlrs=monitor.handlerList.size();
   if (numHndlrs>0) {
   	String listItems[]=new String[numHndlrs];
   	Iterator it=monitor.handlerList.iterator();
	docTypeHandler dh;
	int curI=0;
	while(it.hasNext()) {
		dh=(docTypeHandler)it.next();
		listItems[curI]=dh.descName();
		curI++;
		}
	handlerList.setListData(listItems);
   	}
 } // end for setlist
 
 
public void removeItemAt(int removeItemNum) {
if (removeItemNum!=-1) {
	int newNum=handlerList.getModel().getSize()-1;
	//System.out.println("Item to skip: "+(String)AllPages.getModel().getElementAt(removeItemNum));
	if (newNum==0) handlerList.removeAll();
	else if (newNum>0) {
		String [] nData=new String[newNum];
		int curAd=0;
		for (int i=0;i<newNum+1;i++) {
			if (i!=removeItemNum) {
				 nData[curAd]=(String)handlerList.getModel().getElementAt(i);
				 curAd++;
				 }
			} // end for adding
		handlerList.setListData(nData);
		} // end if more than one item
	} // end if not zero
} // end for removeItemAt


public void setLafs() {
	int matchInt=0;
	boolean foundMtch=false;
	ArrayList lafs=monitor.getLafs();
	if (!lafs.isEmpty()) {
		int numLafs=lafs.size();
		Iterator it=lafs.iterator();
		String laf;
		int curLF=0;
		while(it.hasNext()) {
			laf=(String)it.next();
			if (!monitor.lafChosen.equals("")) {
				matchInt=curLF;
				foundMtch=true;
				}
			uiChoice.addItem(laf);
			curLF++;
			}
		}
	if (foundMtch) uiChoice.setSelectedIndex(matchInt);
} // end for setlafs

public void cb() {
	if (!sendEmailBx.isSelected()) {
		addEmailButton.setEnabled(false);
		removeEmailButton.setEnabled(false);
		editEmailButton.setEnabled(false);
		gatewayUserField.setEnabled(false);
		gatewayPwdField.setEnabled(false);
		gateWayField.setEnabled(false);
		emailList.setEnabled(false);
		textRB.setEnabled(false);
		htmlRB.setEnabled(false);
		}
	else {
		addEmailButton.setEnabled(true);
		removeEmailButton.setEnabled(true);
		editEmailButton.setEnabled(true);
		gatewayUserField.setEnabled(true);
		gatewayPwdField.setEnabled(true);
		gateWayField.setEnabled(true);
		emailList.setEnabled(true);
		textRB.setEnabled(true);
		htmlRB.setEnabled(true);
		}
}

class CbListener implements ActionListener { 
	public void actionPerformed(ActionEvent e) {
	String CMD=e.getActionCommand();
	cb();
	}  // end of action
} // end for radio listener

public void addEmail(String toAdd) {
	// adds email to our list
	monitor.addEmail(toAdd);
	emailList.setListData(monitor.getEmails());
} // end for addEmail

public void replaceEmail(int idx, String toRep) {
	monitor.setEmail(idx, toRep);
	emailList.setListData(monitor.getEmails());
}

public void removeEmailItem(int toRem) {
	monitor.removeEmail(toRem);
	emailList.setListData(monitor.getEmails());
}

} // end for class
