public class SpiderUrl {
	String href="";
	boolean spidered=false;
	boolean deadlink=false;
	String contentType="UNKNOWN";
	String errCode="";
	long lastMod=0;
	long size=0;
	String md5="";
	int indexLocation=-1;

SpiderUrl (String href) {
	if (href.indexOf("|")==-1) this.href=href;
	else {
		/* loads each value seperated by a "|" */
		int curPart=0;
		char c=' ';
		int lineLen=href.length();
		long tmpVl=0;
		StringBuffer tempVl=new StringBuffer();
		for (int i=0;i<lineLen;i++) {
			c=href.charAt(i);
			if ((c=='|') || (i==lineLen-1)) {
				if (i==lineLen-1) tempVl.append(c);
				switch (curPart) {
					case 0 : // href
						this.href=tempVl.toString();
						break;
					case 1 : //
						try { 
							tmpVl=Long.parseLong(tempVl.toString());
							this.lastMod=tmpVl;
							}
						catch (Exception eR) {
							eR.printStackTrace();
							}
						break;
					case 2 : // size
						try { 
							tmpVl=Long.parseLong(tempVl.toString());
							this.size=tmpVl;
							}
						catch (Exception eR) {
							eR.printStackTrace();
							}
						break;
					case 3 : // type
						this.contentType=tempVl.toString();
						break;
					default : // md5
						this.md5=tempVl.toString();
						break;
					}
				curPart++;
				tempVl=new StringBuffer();
				}
			else tempVl.append(c);
			}
		
		}
} // end for constructor

public void setMd5(String toSet) { md5=toSet; }
public String getMd5() { return md5; }
public String getUrl() { return href; }
public boolean spidered() { return spidered; }
public void setSpidered(boolean toSet) { spidered=toSet; }
public boolean isDeadLink() { return deadlink; }
public void setDead(boolean toSet) { deadlink=toSet; }
public String getErr() { return errCode; }
public void setErrCode(String toSet) { errCode=toSet; }
public void setLastModified(long toSet) { lastMod=toSet; }
public long getLastModified() { return lastMod; }
public void setSize(long toSet) { size=toSet; }
public long getSize() { return size; }
public void setContentType(String toSet) { contentType=toSet; }
public String getContentType() { return contentType; }
public void setIndexLocation(int toSet) { indexLocation=toSet; }
public int getIndexLocation() { return indexLocation; }

} // end for class