import java.io.*;
import org.apache.poi.hwpf.HWPFDocument;
import org.apache.poi.hwpf.usermodel.CharacterRun;
import org.apache.poi.hwpf.usermodel.Paragraph;
import org.apache.poi.hwpf.usermodel.TableProperties;
import org.apache.poi.hwpf.sprm.TableSprmUncompressor;
import org.apache.poi.hwpf.sprm.ParagraphSprmUncompressor;
import org.apache.poi.hwpf.model.*;
import org.apache.poi.hwpf.model.io.*;
import org.apache.poi.hwpf.usermodel.*;

class WordToText
{
    String origFileName;
    String tempFile;
    HWPFDocument wd;

    WordToText(String origFileName,
               String tempFile)
    {
        this.tempFile = tempFile;
        this.origFileName = origFileName;
    }


public static void main (String[] args) {
	WordToText wt=new WordToText(args[0], args[1]);
	wt.getText();
}

public void getText() {
	try {
		wd = new HWPFDocument(new FileInputStream(origFileName));
            	Range r = wd.getRange();
		String str = r.text();
		saveFile(str);
        }
        catch (Exception eN)
        {
            System.out.println("Error reading document:" + origFileName + "\n"
                               + eN.toString());
		eN.printStackTrace();
        }
    }

public void saveFile(String saveStr) {
	boolean error=false;
	try {
		File saveFile;
    		FileWriter writer = new FileWriter(tempFile);
		int saveStrLen=saveStr.length();
		for (int i=0;i<saveStrLen;i++)  writer.write((int)saveStr.charAt(i));
		writer.close();
		}
	catch (Exception eF) {
		eF.printStackTrace();
		} // end for catch

}

}